aboutsummaryrefslogtreecommitdiffhomepage
diff options
context:
space:
mode:
-rw-r--r--src/main/java/com/google/devtools/build/lib/skyframe/BazelSkyframeExecutorConstants.java13
-rw-r--r--src/test/shell/bazel/BUILD8
-rwxr-xr-xsrc/test/shell/bazel/bazelignore_test.sh45
3 files changed, 65 insertions, 1 deletions
diff --git a/src/main/java/com/google/devtools/build/lib/skyframe/BazelSkyframeExecutorConstants.java b/src/main/java/com/google/devtools/build/lib/skyframe/BazelSkyframeExecutorConstants.java
index f7b19ce28f..331a4e4836 100644
--- a/src/main/java/com/google/devtools/build/lib/skyframe/BazelSkyframeExecutorConstants.java
+++ b/src/main/java/com/google/devtools/build/lib/skyframe/BazelSkyframeExecutorConstants.java
@@ -28,8 +28,19 @@ public class BazelSkyframeExecutorConstants {
public static final ImmutableSet<PathFragment> HARDCODED_BLACKLISTED_PACKAGE_PREFIXES =
ImmutableSet.of();
+ /**
+ * The file .bazelignore can be used to specify directories to be ignored by bazel
+ *
+ * <p>This is intended for directories containing non-bazel sources (either generated,
+ * or versioned sources built by other tools) that happen to contain a file called BUILD.</p>
+ *
+ * <p>For the time being, this ignore functionality is limited by the fact that it is
+ * applied only after pattern expansion. So if a pattern expansion fails (e.g., due to
+ * symlink-cycles) and therefore fails the build, this ignore functionality currently
+ * has no chance to kick in.</p>
+ */
public static final PathFragment ADDITIONAL_BLACKLISTED_PACKAGE_PREFIXES_FILE =
- PathFragment.EMPTY_FRAGMENT;
+ PathFragment.create(".bazelignore");
public static final CrossRepositoryLabelViolationStrategy
CROSS_REPOSITORY_LABEL_VIOLATION_STRATEGY = CrossRepositoryLabelViolationStrategy.ERROR;
diff --git a/src/test/shell/bazel/BUILD b/src/test/shell/bazel/BUILD
index e8fd9c09a6..eafe9aadea 100644
--- a/src/test/shell/bazel/BUILD
+++ b/src/test/shell/bazel/BUILD
@@ -417,6 +417,14 @@ sh_test(
)
sh_test(
+ name = "bazelignore_test",
+ size = "medium",
+ srcs = ["bazelignore_test.sh"],
+ data = [":test-deps"],
+ tags = ["no_windows"],
+)
+
+sh_test(
name = "workspace_resolved_test",
size = "medium",
srcs = ["workspace_resolved_test.sh"],
diff --git a/src/test/shell/bazel/bazelignore_test.sh b/src/test/shell/bazel/bazelignore_test.sh
new file mode 100755
index 0000000000..3e6aa1c601
--- /dev/null
+++ b/src/test/shell/bazel/bazelignore_test.sh
@@ -0,0 +1,45 @@
+#!/bin/bash
+#
+# Copyright 2016 The Bazel Authors. All rights reserved.
+#
+# Licensed under the Apache License, Version 2.0 (the "License");
+# you may not use this file except in compliance with the License.
+# You may obtain a copy of the License at
+#
+# http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS,
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+# See the License for the specific language governing permissions and
+# limitations under the License.
+#
+# An end-to-end test that Bazel's experimental UI produces reasonable output.
+
+# Load the test setup defined in the parent directory
+CURRENT_DIR="$(cd "$(dirname "${BASH_SOURCE[0]}")" && pwd)"
+source "${CURRENT_DIR}/../integration_test_setup.sh" \
+ || { echo "integration_test_setup.sh not found!" >&2; exit 1; }
+
+#### SETUP #############################################################
+
+set -e
+
+test_broken_BUILD_files_ignored() {
+ rm -rf work && mkdir work && cd work
+ touch WORKSPACE
+ mkdir -p ignoreme/deep/reallydep/stillignoreme
+ echo This is a broken BUILD file > ignoreme/BUILD
+ echo This is a broken BUILD file > ignoreme/deep/BUILD
+ echo This is a broken BUILD file > ignoreme/deep/reallydep/BUILD
+ echo This is a broken BUILD file > ignoreme/deep/reallydep/stillignoreme/BUILD
+ touch BUILD
+ bazel build ... && fail "Expected failure" || :
+
+ echo; echo
+ echo ignoreme > .bazelignore
+ bazel build ... \
+ || fail "directory mentioned in .bazelrc not ignored as it should"
+}
+
+run_suite "Integration tests for .bazelignore"